/*
 * test-trid-lu1.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "trid-lu1.h"

double MAXINT;

void multiply1(int n, double *Ax, double *AL, double *AD, double *AU, double *x)
{
   int i;
   Ax[1] = AD[1] * x[1] + AU[1] * x[2];
   for (i = 2; i < n; i++)
     Ax[i] = AL[i] * x[i-1] + AD[i] * x[i] + AU[i] * x[i+1];
   Ax[n] = AL[n] * x[n-1] + AD[n] * x[n];
}

double drandom()
{
  return random() / MAXINT;
}

int main()
{
  int i, n;
  double *al, *ad, *au, *b, *x, error;

  MAXINT = pow(2.0, 31.0) - 1.0;

#ifdef HEAT
  n = 7;
#else
  n = 20;
#endif
  al = (double *)malloc(sizeof(double) * (n+1));
  ad = (double *)malloc(sizeof(double) * (n+1));
  au = (double *)malloc(sizeof(double) * (n+1));
  b  = (double *)malloc(sizeof(double) * (n+1));
  x  = (double *)malloc(sizeof(double) * (n+1));
  for (i = 1; i <= n; i++) {
#ifdef HEAT
    al[i] = - 0.5; ad[i] = 2.0; au[i] = - 0.5;
#else
    al[i] = - drandom(); ad[i] = 1.0 + 2.0 * drandom(); au[i] = - drandom();
#endif
    x[i] = i;
  }
  multiply1(n, b, al, ad, au, x);
  trilu1(n, al, ad, au);
#ifdef HEAT
  for (i = 1; i <= n; i++) {
    if (i == 1)
      printf("                     %20.15g %20.15g\n", ad[i], au[i]);
    else if (i != n)
      printf("%20.15g %20.15g %20.15g\n", al[i], ad[i], au[i]);
    else
      printf("%20.15g %20.15g\n", al[i], ad[i]);
  }
#endif
  trisol1(n, al, ad, au, b);
  error = 0.0;
  for (i = 1; i <= n; i++) {
    error += fabs(x[i] - b[i]);
    printf("x[%d]=%g, b[%d]=%g, diff=%g\n", i, x[i], i, b[i], x[i] - b[i]);
  }
  printf("L1 error=%g\n", error);
  return 0;
}
