/* trid-lu1.c -- 3 Gauss ξõˡǲ */

#include "trid-lu1.h"

/* 3 (󤬻гѤǤϢΩ1Τ) Ax=b 
 *
 *   
 *     n: ̤οθĿ
 *     al,ad,au: ϢΩ1η
 *       (al: гβ¦ i.e. ʬ (lower part)
 *        ad: г       i.e. гʬ (diagonal part)
 *        au: гξ¦ i.e. 廰ʬ (upper part)
 *        Ĥޤ
 *
 *         ad[1] au[1]   0   .................. 0
 *         al[2] ad[2] au[2]   0  ............. 0
 *           0   al[3] ad[3] au[3]  0 ......... 0
 *                         ....................
 *                         al[n-1] ad[n-1] au[n-1]
 *                           0     al[n]   ad[n]

 *        al[i] = A_{i,i-1}, ad[i] = A_{i,i}, au[i] = A_{i,i+1},
 *        al[1], au[n] ϰ̣ʤ)
 *
 *     b: ϢΩ1αդδΥ٥ȥ
 *        (ź 1 顣i.e. b[1],b[2],...,b[n] ˥ǡäƤ롣)
 *   
 *     al,ad,au: Ϥ LU ʬ򤷤
 *     b: ϢΩ1β
 *   ǽ
 *      call ȷ LU ʬ򤷤Τ֤Τǡ
 *     ʸƱ˴ؤϢΩ1򤯤ˡ
 *     ؿ trisol1() Ȥ롣
 *   
 *     Gauss ξõˡѤƤ뤬ԥܥåȤϤƤ
 *     ΤǡԥܥåȤ򤷤ƤʤΤǡͤǤ
 *     ʤɤŬڤʾ郎ʤϷ̤ݾڤǤʤ
 */

void trid1(int n, double *al, double *ad, double *au, double *b)
{
  trilu1(n,al,ad,au);
  trisol1(n,al,ad,au,b);
}

/* гѹ LU ʬ (pivoting ʤ) */
void trilu1(int n, double *al, double *ad, double *au)
{
  int i;
  /* ʾõ (forward elimination) */
  for (i = 1; i < n; i++) ad[i + 1] -= au[i] * al[i + 1] / ad[i];
}

/* LU ʬѤߤλгѹ򷸿˻3 */
void trisol1(int n, double *al, double *ad, double *au, double *b)
{
  int i;
  /* ʾõ (forward elimination) */
  for (i = 1; i < n; i++) b[i + 1] -= b[i] * al[i + 1] / ad[i];
  /*  (backward substitution) */
  b[n] /= ad[n];
  for (i = n - 1; i >= 1; i--) b[i] = (b[i] - au[i] * b[i + 1]) / ad[i];
}
